Index: XIOS3/trunk/src/io/nc4_data_output.cpp
===================================================================
--- XIOS3/trunk/src/io/nc4_data_output.cpp	(revision 2498)
+++ XIOS3/trunk/src/io/nc4_data_output.cpp	(revision 2507)
@@ -202,6 +202,6 @@
                  else bounds_latid = "bounds_"+latName+appendDomid;
 
-                 SuperClassWriter::addDimension(dimXid, domain->ni);
-                 SuperClassWriter::addDimension(dimYid, domain->nj);
+                 SuperClassWriter::addDimension(dimXid, domain->niValue_);
+                 SuperClassWriter::addDimension(dimYid, domain->njValue_);
 
                  if (domain->hasBounds)
@@ -210,16 +210,16 @@
                  if (context->intraCommSize_ > 1)
                  {
-                   this->writeLocalAttributes(domain->ibegin,
-                                              domain->ni,
-                                              domain->jbegin,
-                                              domain->nj,
+                   this->writeLocalAttributes(domain->ibeginValue_,
+                                              domain->niValue_,
+                                              domain->jbeginValue_,
+                                              domain->njValue_,
                                               appendDomid);
 
                    if (singleDomain)
                     this->writeLocalAttributes_IOIPSL(dimXid, dimYid,
-                                                      domain->ibegin,
-                                                      domain->ni,
-                                                      domain->jbegin,
-                                                      domain->nj,
+                                                      domain->ibeginValue_,
+                                                      domain->niValue_,
+                                                      domain->jbeginValue_,
+                                                      domain->njValue_,
                                                       domain->ni_glo,domain->nj_glo,
                                                       context->intraCommRank_,context->intraCommSize_);
@@ -373,7 +373,7 @@
                      std::vector<StdSize> start(2) ;
                      std::vector<StdSize> count(2) ;
-                     start[1]=domain->ibegin;
-                     start[0]=domain->jbegin;
-                     count[1]=domain->ni ; count[0]=domain->nj ;
+                     start[1]=domain->ibeginValue_;
+                     start[0]=domain->jbeginValue_;
+                     count[1]=domain->niValue_ ; count[0]=domain->njValue_ ;
 
                      if (domain->hasLonLat)
@@ -391,14 +391,14 @@
                        std::vector<StdSize> count(1) ;
                        
-                       start[0]=domain->jbegin;
-                       count[0]=domain->nj;
+                       start[0]=domain->jbeginValue_;
+                       count[0]=domain->njValue_;
                        CArray<double,1> lat;
-                       lat.resize( domain->nj.getValue() );
-                       for (int j=0;j<domain->nj.getValue();j++) lat(j) = domain->latvalue(j*domain->ni.getValue());
+                       lat.resize( domain->njValue_);
+                       for (int j=0;j<domain->njValue_;j++) lat(j) = domain->latvalue(j*domain->niValue_);
                        SuperClassWriter::writeData(CArray<double,1>(lat.copy()), latid, isCollective, 0,&start,&count);
 
-                       start[0]=domain->ibegin;
-                       count[0]=domain->ni;
-                       CArray<double,1> lon = domain->lonvalue(Range(0,domain->ni-1));
+                       start[0]=domain->ibeginValue_;
+                       count[0]=domain->niValue_;
+                       CArray<double,1> lon = domain->lonvalue(Range(0,domain->niValue_-1));
                        SuperClassWriter::writeData(CArray<double,1>(lon.copy()), lonid, isCollective, 0,&start,&count);
                      }
@@ -419,9 +419,9 @@
                    {
                      start[2] = 0;
-                     start[1] = domain->ibegin;
-                     start[0] = domain->jbegin;
+                     start[1] = domain->ibeginValue_;
+                     start[0] = domain->jbeginValue_;
                      count[2] = domain->nvertex;
-                     count[1] = domain->ni;
-                     count[0] = domain->nj;
+                     count[1] = domain->niValue_;
+                     count[0] = domain->njValue_;
                    }
                  
@@ -435,8 +435,8 @@
                    std::vector<StdSize> count(2);
 
-                   start[1] = domain->ibegin;
-                   start[0] = domain->jbegin;
-                   count[1] = domain->ni;
-                   count[0] = domain->nj;
+                   start[1] = domain->ibeginValue_;
+                   start[0] = domain->jbeginValue_;
+                   count[1] = domain->niValue_;
+                   count[0] = domain->njValue_;
                    
                    SuperClassWriter::writeData(domain->areavalue, areaId, isCollective, 0, &start, &count);
@@ -703,6 +703,6 @@
                else
                {
-                 startNodes[0] = domain->ibegin;
-                 countNodes[0] = domain->ni ;
+                 startNodes[0] = domain->ibeginValue_;
+                 countNodes[0] = domain->niValue_ ;
                }
 
@@ -726,12 +726,12 @@
                else
                {
-                 startEdges[0] = domain->ibegin;
-                 countEdges[0] = domain->ni;
+                 startEdges[0] = domain->ibeginValue_;
+                 countEdges[0] = domain->niValue_;
                  startNodes[0] = domain->mesh->node_start;
                  countNodes[0] = domain->mesh->node_count;
                  if (countNodes[0]==0) startNodes[0]=0 ; // for netcdf error
-                 startEdgeNodes[0] = domain->ibegin;
+                 startEdgeNodes[0] = domain->ibeginValue_;
                  startEdgeNodes[1] = 0;
-                 countEdgeNodes[0] = domain->ni;
+                 countEdgeNodes[0] = domain->niValue_;
                  countEdgeNodes[1] = 2;
                }
@@ -763,6 +763,6 @@
                else
                {
-                 startFaces[0] = domain->ibegin;
-                 countFaces[0] = domain->ni ;
+                 startFaces[0] = domain->ibeginValue_;
+                 countFaces[0] = domain->niValue_ ;
                  startNodes[0] = domain->mesh->node_start;
                  countNodes[0] = domain->mesh->node_count;
@@ -785,6 +785,6 @@
                  countEdgeFaces[1]= 2;
                  
-                 startFaceConctv[0] = domain->ibegin;
-                 countFaceConctv[0] = domain->ni;
+                 startFaceConctv[0] = domain->ibeginValue_;
+                 countFaceConctv[0] = domain->niValue_;
                  startFaceConctv[1] = 0;
                  countFaceConctv[1] = domain->nvertex;
@@ -998,9 +998,9 @@
                  else
                  {
-                   start[0]=domain->ibegin;
-                   count[0]=domain->ni;
-                   startBounds[0]=domain->ibegin;
+                   start[0]=domain->ibeginValue_;
+                   count[0]=domain->niValue_;
+                   startBounds[0]=domain->ibeginValue_;
                    startBounds[1]=0 ;
-                   countBounds[0]=domain->ni;
+                   countBounds[0]=domain->niValue_;
                    countBounds[1]=nvertex ;
                  }
@@ -1110,5 +1110,5 @@
           if (!axis->label.isEmpty() && !SuperClassWriter::dimExist(strId)) SuperClassWriter::addDimension(strId, stringArrayLen);
 
-          if (axis->hasValue || !axis->label.isEmpty())
+          if (axis->hasValue() || !axis->label.isEmpty())
           {
             if (!axis->label.isEmpty()) dims.push_back(strId);
@@ -1499,5 +1499,5 @@
               }
 
-              firstGlobalIndex = domain->ibegin + domain->jbegin * domain->ni_glo;
+              firstGlobalIndex = domain->ibeginValue_ + domain->jbeginValue_ * domain->ni_glo;
 
               domain->addRelFileCompressed(this->filename);
@@ -2323,10 +2323,10 @@
                         if ((domain->type) != CDomain::type_attr::unstructured)
                         {
-                          start.push_back(domain->jbegin);
-                          count.push_back(domain->nj);
+                          start.push_back(domain->jbeginValue_);
+                          count.push_back(domain->njValue_);
                         }
                         --idx;
-                        start.push_back(domain->ibegin);
-                        count.push_back(domain->ni);
+                        start.push_back(domain->ibeginValue_);
+                        count.push_back(domain->niValue_);
                         --idx;
                       }
@@ -2383,11 +2383,11 @@
                       if ((domain->type) != CDomain::type_attr::unstructured)
                       {
-                        start.push_back(domain->jbegin);
-                        count.push_back(domain->nj);
+                        start.push_back(domain->jbeginValue_);
+                        count.push_back(domain->njValue_);
                       }
                       --idx ;
 
-                        start.push_back(domain->ibegin);
-                        count.push_back(domain->ni);
+                        start.push_back(domain->ibeginValue_);
+                        count.push_back(domain->niValue_);
                       --idx ;
                       --idxDomain;
Index: XIOS3/trunk/src/manager/services_manager.cpp
===================================================================
--- XIOS3/trunk/src/manager/services_manager.cpp	(revision 2498)
+++ XIOS3/trunk/src/manager/services_manager.cpp	(revision 2507)
@@ -227,7 +227,9 @@
     int leader ;
 
-    services_.clear() ;
     int nbServices ;
     buffer>>nbServices ;
+    bool newServices = nbServices != services_.size() ; 
+
+    services_.clear() ;
 
     for(int i=0;i<nbServices;i++) 
@@ -235,4 +237,6 @@
       buffer>>poolId>>serviceId>>partitionId>>type>>size>>nbPartitions>>leader ;
       services_[std::tuple<std::string,std::string,int>(poolId,serviceId,partitionId)]=std::make_tuple(type,size,nbPartitions,leader) ;
+      if (newServices)
+        info(40)<<"Receive new services informations : "<<poolId<<"::"<<serviceId<<"::"<<partitionId<<" => type : "<<type<<"  size : "<<size<<"  nbPartitions : "<<nbPartitions<<"  leader : "<<leader<<endl ;
     }
   }
@@ -256,14 +260,13 @@
                                         int& size, int& nbPartitions, int& leader, bool wait)
   {
-    
     winServices_->lockWindowShared(managerGlobalLeader_) ;
     winServices_->updateFromLockedWindow(managerGlobalLeader_, this, &CServicesManager::servicesDumpIn) ;
     winServices_->unlockWindow(managerGlobalLeader_) ;
-
+    
+    if (wait) waitServiceRegistration(poolId, serviceId, partitionId) ;
     auto it=services_.find(std::tuple<std::string,std::string,int>(poolId,serviceId,partitionId)) ;
-    if ( it == services_.end() && !wait) return false ;
+    if ( it == services_.end()) return false ;
     else
     {
-      if (wait) waitServiceRegistration(poolId, serviceId, partitionId) ;
       type= std::get<0>(it->second); 
       size= std::get<1>(it->second); 
@@ -279,6 +282,5 @@
     int size ;
     int nbPartitions;
-    //return getServiceInfo(poolId, serviceId, partitionId, type, size, nbPartitions, leader, wait) ;
-    return getServiceInfo(poolId, serviceId, partitionId, type, size, nbPartitions, leader) ;
+    return getServiceInfo(poolId, serviceId, partitionId, type, size, nbPartitions, leader, wait) ;
   }
 
@@ -288,6 +290,5 @@
     int nbPartitions;
     int leader;
-    //return getServiceInfo(poolId, serviceId, partitionId, type, size, nbPartitions, leader, wait) ;
-    return getServiceInfo(poolId, serviceId, partitionId, type, size, nbPartitions, leader) ;
+    return getServiceInfo(poolId, serviceId, partitionId, type, size, nbPartitions, leader, wait) ;
   }
 
@@ -297,13 +298,12 @@
     int type;
     int leader;
-    //return getServiceInfo(poolId, serviceId, partitionId, type, size, nbPartitions, leader, wait) ;
-    return getServiceInfo(poolId, serviceId, partitionId, type, size, nbPartitions, leader) ;
+    return getServiceInfo(poolId, serviceId, partitionId, type, size, nbPartitions, leader, wait) ;
   }
 
   bool CServicesManager::hasService(const std::string& poolId, const std::string& serviceId, const int& partitionId)
   {
-    winServices_->lockWindow(managerGlobalLeader_,0) ;
-    winServices_->updateFromWindow(managerGlobalLeader_, this, &CServicesManager::servicesDumpIn) ;
-    winServices_->unlockWindow(managerGlobalLeader_,0) ;
+    winServices_->lockWindowShared(managerGlobalLeader_) ;
+    winServices_->updateFromLockedWindow(managerGlobalLeader_, this, &CServicesManager::servicesDumpIn) ;
+    winServices_->unlockWindow(managerGlobalLeader_) ;
     auto it=services_.find(std::tuple<std::string, std::string, int>(poolId, serviceId, partitionId)) ;
     if ( it == services_.end()) return false ;
Index: XIOS3/trunk/src/mpi_tools.cpp
===================================================================
--- XIOS3/trunk/src/mpi_tools.cpp	(revision 2498)
+++ XIOS3/trunk/src/mpi_tools.cpp	(revision 2507)
@@ -28,4 +28,7 @@
 
   template<>
+  MPI_Datatype MPI_GetType<bool>(void) { return MPI_CXX_BOOL ;}
+
+  template<>
   MPI_Datatype MPI_GetType<char>(void) { return MPI_CHAR ;}
 
Index: XIOS3/trunk/src/node/axis.cpp
===================================================================
--- XIOS3/trunk/src/node/axis.cpp	(revision 2498)
+++ XIOS3/trunk/src/node/axis.cpp	(revision 2507)
@@ -24,6 +24,6 @@
       : CObjectTemplate<CAxis>()
       , CAxisAttributes(), isChecked(false), relFiles()
-      , hasBounds(false), isCompressible_(false)
-      , transformationMap_(), hasValue(false), hasLabel(false)
+      , hasBounds_(false), isCompressible_(false)
+      , transformationMap_()
       , clients()
    {
@@ -33,6 +33,6 @@
       : CObjectTemplate<CAxis>(id)
       , CAxisAttributes(), isChecked(false), relFiles()
-      , hasBounds(false), isCompressible_(false)
-      , transformationMap_(), hasValue(false), hasLabel(false)
+      , hasBounds_(false), isCompressible_(false)
+      , transformationMap_()
       , clients()
    {
@@ -56,4 +56,6 @@
      m["temporal_splitting"] = TRANS_TEMPORAL_SPLITTING;
      m["duplicate_scalar"] = TRANS_DUPLICATE_SCALAR_TO_AXIS;
+     m["redistribute_axis"] = TRANS_REDISTRIBUTE_AXIS;
+
      return true;
    }
@@ -165,7 +167,7 @@
          size += CArray<bool,1>::size(n_glo);
          size += CArray<double,1>::size(n_glo);
-         if (hasBounds)
+         if (hasBounds_)
            size += CArray<double,2>::size(2*n_glo);
-         if (hasLabel)
+         if (hasLabel_)
           size += CArray<StdString,1>::size(n_glo);
        }
@@ -198,7 +200,7 @@
          size += CArray<bool,1>::size(it->second.size());
          size += CArray<double,1>::size(it->second.size());
-         if (hasBounds)
+         if (hasBounds_)
            size += CArray<double,2>::size(2 * it->second.size());
-         if (hasLabel)
+         if (hasLabel_)
            size += CArray<StdString,1>::size(it->second.size());
 
@@ -457,5 +459,5 @@
                                    << ") than the one defined by the \'size\' attribute (" << n.getValue() << ").")
           else return false ; 
-        this->hasValue = true;
+        this->hasValue_ = true;
       }
 
@@ -567,7 +569,7 @@
                                << "Bounds size is "<< bounds.extent(0) << " x " << bounds.extent(1) << ".")
          else return false ;
-       hasBounds = true;
-     }
-     else hasBounds = false;
+       hasBounds_ = true;
+     }
+     else hasBounds_ = false;
      return true ;
    }
@@ -585,7 +587,7 @@
                               << "label size is "<< label.extent(0)<<  " .")
         else return false ;
-      hasLabel = true;
-    }
-    else hasLabel = false;
+      hasLabel_ = true;
+    }
+    else hasLabel_ = false;
     return true ;
   }
@@ -1163,5 +1165,5 @@
     CContext* context = CContext::getCurrent();
 
-    if (hasValue)
+    if (hasValue_)
     {
       { // send level value
@@ -1173,5 +1175,5 @@
     }
 
-    if (hasBounds)
+    if (hasBounds_)
     {
       { // send bounds level value
@@ -1183,5 +1185,5 @@
     }
 
-    if (hasLabel)
+    if (hasLabel_)
     {
       { // send label
Index: XIOS3/trunk/src/node/axis.hpp
===================================================================
--- XIOS3/trunk/src/node/axis.hpp	(revision 2498)
+++ XIOS3/trunk/src/node/axis.hpp	(revision 2507)
@@ -175,8 +175,12 @@
          bool isEqual(CAxis* axis);
 
-      public: 
-        bool hasValue;        
-        bool hasBounds;
-        bool hasLabel;
+      private: 
+        bool hasValue_= false;        
+        bool hasBounds_= false;
+        bool hasLabel_= false;
+      public:
+        bool hasValue(void) { return hasValue_ ;}
+        bool hasBounds(void) { return hasBounds_ ;}
+        bool hasLabel(void) { return hasLabel_ ;}
 
       private:
Index: XIOS3/trunk/src/node/context.cpp
===================================================================
--- XIOS3/trunk/src/node/context.cpp	(revision 2498)
+++ XIOS3/trunk/src/node/context.cpp	(revision 2507)
@@ -7,4 +7,5 @@
 #include "duration.hpp"
 
+#include "online_context_client.hpp"
 #include "legacy_context_client.hpp"
 #include "legacy_context_server.hpp"
@@ -662,6 +663,5 @@
       
       int serviceType ;
-      //if (intraCommRank_==0) CXios::getServicesManager()->getServiceType(poolId, serviceId, 0, serviceType, true) ;
-      if (intraCommRank_==0) CXios::getServicesManager()->getServiceType(poolId, serviceId, 0, serviceType) ;
+      if (intraCommRank_==0) CXios::getServicesManager()->getServiceType(poolId, serviceId, 0, serviceType, true) ;
       MPI_Bcast(&serviceType,1,MPI_INT,0,intraComm_) ;
       
@@ -679,8 +679,13 @@
   vector<CContextClient*> CContext::getContextClient(const string& poolId, const string& serviceId)
   {
-    vector<pair<CContextClient*,CContextServer*>> clientServers ;
-    getServerInterComm(poolId, serviceId, clientServers ) ;
-    vector<CContextClient*> ret ;
-    for(auto& clientServer : clientServers) ret.push_back(clientServer.first) ;
+     vector<CContextClient*> ret ;
+    
+    if (serviceId=="attached") ret.push_back(onlineContextClient_) ;
+    else
+    {
+      vector<pair<CContextClient*,CContextServer*>> clientServers ;
+      getServerInterComm(poolId, serviceId, clientServers ) ;
+      for(auto& clientServer : clientServers) ret.push_back(clientServer.first) ;
+    }
     return ret ;
   }
@@ -808,5 +813,4 @@
       if (serviceType_==CServicesManager::CLIENT)
       {
-//ym        doPreTimestepOperationsForEnabledReadModeFiles(); // For now we only use server level 1 to read data
         triggerLateFields() ;
 
@@ -986,4 +990,6 @@
 
      CTimer::get("Context : close definition").resume() ;
+
+     onlineContextClient_=CContextClient::getNew<CContextClient::online>(this,intraComm_, intraComm_);
           
      // create intercommunicator with servers. 
@@ -1146,7 +1152,10 @@
     {
       for(auto field : fileInField) 
-      {
-        field->sendFieldToInputFileServer() ;
-        field->connectToServerInput(garbageCollector) ; // connect the field to server filter
+        if (field->getContextClient()->getType() != CContextClient::online) field->sendFieldToInputFileServer() ;
+
+      for(auto field : fileInField) 
+      {
+        if (field->getContextClient()->getType() == CContextClient::online) field->connectToOnlineReader(garbageCollector) ;
+        else field->connectToServerInput(garbageCollector) ; // connect the field to server filter
         fileInFields_.push_back(field) ;
       }
@@ -1158,7 +1167,9 @@
       for(auto field : fileOutField) 
       {
-        field->connectToFileServer(garbageCollector) ; // connect the field to server filter
-      }
-      for(auto field : fileOutField) field->sendFieldToFileServer() ;
+        if (field->getContextClient()->getType() == CContextClient::online)  field->connectToOnlineWriter(garbageCollector) ;
+        else  field->connectToFileServer(garbageCollector) ; // connect the field to server filter
+      }
+      for(auto field : fileOutField) 
+        if (field->getContextClient()->getType() != CContextClient::online) field->sendFieldToFileServer() ;
     }
 
@@ -1177,5 +1188,6 @@
       for(auto field : fileInField) 
       {
-        field->connectToServerToClient(garbageCollector) ;
+        if (field->getContextClient()->getType() == CContextClient::online) field->connectToOnlineReader(garbageCollector) ;
+        else field->connectToServerToClient(garbageCollector) ;
       }
     }
@@ -1232,6 +1244,8 @@
     if (serviceType_==CServicesManager::CLIENT) 
     {
-      for(auto field : fileOutField) slaves[clientsId_[field->getContextClient()]] = field->getContextClient() ; 
-      for(auto field : fileInField) slaves[clientsId_[field->getContextClient()]] = field->getContextClient() ; 
+      for(auto field : fileOutField)
+        if (field->getContextClient()->getType()!=CContextClient::online)  slaves[clientsId_[field->getContextClient()]] = field->getContextClient() ; 
+      for(auto field : fileInField) 
+        if (field->getContextClient()->getType()!=CContextClient::online)  slaves[clientsId_[field->getContextClient()]] = field->getContextClient() ; 
     }
     else if (serviceType_==CServicesManager::GATHERER) 
@@ -1242,10 +1256,9 @@
     for(auto& slaveServer : slaveServers_) sendCloseDefinition(slaveServer) ;
 
-    if (serviceType_==CServicesManager::WRITER)  
-    {
-      createFileHeader();
-    }
-
-    if (serviceType_==CServicesManager::CLIENT) startPrefetchingOfEnabledReadModeFiles();
+    createFileHeader();
+   
+    //if (serviceType_==CServicesManager::CLIENT) startPrefetchingOfEnabledReadModeFiles();
+    if (serviceType_==CServicesManager::CLIENT) 
+       for(auto field : fileInField) field->sendReadDataRequest(getCalendar()->getCurrentDate());  
    
     // send signal to couplerIn context that definition phasis is done
@@ -1356,16 +1369,4 @@
    CATCH_DUMP_ATTR
 
-
-   void CContext::postProcessFilterGraph()
-   TRY
-   {
-     int size = enabledFiles.size();
-     for (int i = 0; i < size; ++i)
-     {
-        enabledFiles[i]->postProcessFilterGraph();
-     }
-   }
-   CATCH_DUMP_ATTR
-
    void CContext::startPrefetchingOfEnabledReadModeFiles()
    TRY
@@ -1375,15 +1376,4 @@
      {
         enabledReadModeFiles[i]->prefetchEnabledReadModeFields();
-     }
-   }
-   CATCH_DUMP_ATTR
-
-   void CContext::doPreTimestepOperationsForEnabledReadModeFiles()
-   TRY
-   {
-     int size = enabledReadModeFiles.size();
-     for (int i = 0; i < size; ++i)
-     {
-        enabledReadModeFiles[i]->doPreTimestepOperationsForEnabledReadModeFields();
      }
    }
@@ -2177,5 +2167,6 @@
         if (serviceType_==CServicesManager::CLIENT) // For now we only use server level 1 to read data
         {
-          doPostTimestepOperationsForEnabledReadModeFiles();
+         // doPostTimestepOperationsForEnabledReadModeFiles();
+          for(auto& field : fileInFields_) field->sendReadDataRequestIfNeeded() ;
           garbageCollector.invalidate(calendar->getCurrentDate());
         }
@@ -2202,15 +2193,9 @@
    CATCH_DUMP_ATTR
 
-   //! Server side: Create header of netcdf file
+   //! Create header of netcdf file
    void CContext::createFileHeader(void)
    TRY
    {
-      vector<CFile*>::const_iterator it;
-
-      //for (it=enabledFiles.begin(); it != enabledFiles.end(); it++)
-      for (it=enabledWriteModeFiles.begin(); it != enabledWriteModeFiles.end(); it++)
-      {
-         (*it)->initWrite();
-      }
+      for(auto& file : filesToWrite_) file->initWrite();
    }
    CATCH_DUMP_ATTR
Index: XIOS3/trunk/src/node/context.hpp
===================================================================
--- XIOS3/trunk/src/node/context.hpp	(revision 2498)
+++ XIOS3/trunk/src/node/context.hpp	(revision 2507)
@@ -141,7 +141,5 @@
          void initReadFiles(void);
          void prepareTimeseries(void);
-         void postProcessFilterGraph();
          void startPrefetchingOfEnabledReadModeFiles();
-         void doPreTimestepOperationsForEnabledReadModeFiles();
          void doPostTimestepOperationsForEnabledReadModeFiles();
          void findFieldsWithReadAccess(void);
@@ -298,7 +296,12 @@
          // Determine context on server or not
          bool hasServer;
-
+      public:
+        void registerFileToWrite(CFile* file) { filesToWrite_.insert(file); } // Add a file that need to be write for example to create headers
+      private:  
+        std::set<CFile*> filesToWrite_ ;  
 
       private:
+        CContextClient* onlineContextClient_=nullptr ;
+        
         std::string defaultPoolWriterId_ ;
         std::string defaultPoolReaderId_ ;
